/*
 * The SmartWeb Framework Maven Plugin
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework Maven Plugin please visit
 *
 *                        http://smartweb.sourceforge.net/maven
 */
package net.smartlab.web.generator;

import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

/**
 * TODO documentation
 * 
 * @author rlogiacco
 */
public class Type {
	
	private Class type;

	private String name;

	private String instance;

	private Collection properties = new ArrayList();


	public Type(Class type) throws IntrospectionException {
		this.type = type;
		this.name = type.getSimpleName();
		this.instance = Character.toLowerCase(name.charAt(0)) + name.substring(1);
		PropertyDescriptor[] descriptors = Introspector.getBeanInfo(type).getPropertyDescriptors();
		for (int i = 0; i < descriptors.length; i++) {
			if (!(descriptors[i].getName().equals("id") || descriptors[i].getName().equals("version") || descriptors[i]
					.getName().equals("class"))) {
				properties.add(new Property(descriptors[i]));
			}
		}
	}

	public String getName() {
		return name;
	}

	public String getInstance() {
		return instance;
	}

	public Collection getProperties() {
		return properties;
	}
	
	public Collection getProperties(int block, int blocks) {
		Collection list = new ArrayList(this.properties);
		Iterator properties = list.iterator();
		for (int i = 0; properties.hasNext(); i++) {
			properties.next();
			if (i % blocks != block - 1) {
				properties.remove();
			}
		}
		return list;
	}

	public boolean hasDateProperty() {
		Iterator properties = this.properties.iterator();
		while (properties.hasNext()) {
			Property property = (Property)properties.next();
			if (property.isDate()) {
				return true;
			}
		}
		return false;
	}

	public boolean equals(Object obj) {
		return type.equals(((Type)obj).type);
	}

	public int hashCode() {
		return type.hashCode();
	}
}