/*
 * The SmartWeb Framework Maven Plugin
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework Maven Plugin please visit
 *
 *                        http://smartweb.sourceforge.net/maven
 */
package net.smartlab.web.maven;

import net.smartlab.web.generator.Main;

import org.apache.maven.plugin.MojoExecutionException;

/**
 * Build strus.xml and form.xml for all defined BusinessObject parsing a
 * velocity template.
 * 
 * @goal struts
 * @phase process-classes
 * @requiresProject
 * @requiresDependencyResolution compile
 * @author gcontartese
 */
public class StrutsGenerator extends AbstractGenerator {

	/**
	 * @see net.smartlab.web.maven.AbstractGenerator#executeFromMain(net.smartlab.web.generator.Main)
	 */
	public void executeFromMain(Main main) throws MojoExecutionException {
		try {
			main.generateStruts();
		} catch (Exception e) {
			throw new MojoExecutionException("Failed to build struts-config.xml from Business Object", e);
		}
	}
}
